Schema.org Blueprints: References
---------------------------------

Schema.org

- [Schema.org](https://schema.org)
- [Schema.org | Wikipedia](https://en.m.wikipedia.org/wiki/Schema.org)
- [Understand how structured data works | Google Search Central](https://developers.google.com/search/docs/advanced/structured-data/intro-structured-data)
- [Schema.org - What, How, Why? | Video](https://www.youtube.com/watch?v=hcahQfN5u9Y) \[video\]
- [Structured data: What's it all about?](https://search-off-the-record.libsyn.com/structured-data-whats-it-all-about) \[podcast\]
  - [Google Discusses Value Of Non-Recommended Structured Data](https://www.searchenginejournal.com/non-recommended-structured-data/445107/)

Schema.org Examples

- [JSON-LD - Structured Data. Made Simple.](https://jsonld.com/)
- [Featured Guides | Google Search Central](https://developers.google.com/search/docs/advanced/structured-data/intro-structured-data)

Drupal Structure Data/RDF/Schema.org

- [RDF in Drupal: What is it and Why Should We Care? Drupal Easy](https://www.drupaleasy.com/blogs/ultimike/2009/06/rdf-drupal-what-it-and-why-should-we-care)
- [RDFa and Drupal](https://dri.es/rdfa-and-drupal)
- [Schema.org And Metadata in Drupal](https://www.droptica.com/blog/schemaorg-and-metadata-drupal/)
- [DrupalEasy Podcast 143: Scheming](https://www.drupaleasy.com/podcast/2015/01/drupaleasy-podcast-143-scheming-schemaorg-integration-d8-stéphane-corlosquet)
- [Structured SEO Data: An overview and how to for Drupal](https://www.videodrupal.org/video/20190714/structured-seo-data-overview-and-how-drupal)  
- [The SEO Magic of Structured Data](https://drupal.tv/external-video/2017-10-23/seo-magic-structured-data)
- [How to Optimize Your Drupal Site with Structured Content](https://drupal.tv/external-video/2017-02-06/how-optimize-your-drupal-site-structured-content)

Drupal Content Architecture

- [How Do You Structure a Complex Content Architecture in Drupal 8?](https://medium.com/@OPTASY.com/how-do-you-structure-a-complex-content-architecture-in-drupal-8-4f8a1362a357)
- [Content Modelling Approach With Drupal](https://www.srijan.net/resources/blog/content-modelling-approach-with-drupal)

Schema.org JSON-LD Examples

- [NY Times](https://validator.schema.org/#url=nytimes.com)
- [Stack overflow](https://validator.schema.org/#url=https%3A%2F%2Fstackoverflow.com%2Fquestions%2F28687653%2Fschema-org-json-ld-where-to-place)
- [Amazon](https://validator.schema.org/#url=https%3A%2F%2Fwww.amazon.com%2FThe-Boys-Season-3%2Fdp%2FB09WV8HF7Q)
- [BBC](https://validator.schema.org/#url=bbc.co.uk)
  - [BBC: News](https://validator.schema.org/#url=https%3A%2F%2Fwww.bbc.com%2Fnews%2Fuk-61626176)
- [MayoClinic](https://validator.schema.org/#url=https%3A%2F%2Fwww.mayoclinic.org%2F)
  - [MayoClinic: Condition](https://validator.schema.org/#url=https%3A%2F%2Fwww.mayoclinic.org%2Fdiseases-conditions%2Facne%2Fdiagnosis-treatment%2Fdrc-20368048)
- [MSKCC](https://validator.schema.org/#url=mskcc.org)
- [GrubHub](https://validator.schema.org/#url=https%3A%2F%2Fwww.grubhub.com%2Frestaurant%2Fred-hot-ii-349-7th-ave-brooklyn%2F347523)
- [Gap](https://validator.schema.org/#url=https%3A%2F%2Fwww.gap.com%2Fbrowse%2Fproduct.do%3Fpid%3D406387012) 
